//+------------------------------------------------------------------+
//|                                                          DRP.mq4 |
//|                                                     Yuriy Tokman |
//|                                            yurietokman@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Yuriy Tokman"
#property link      "yurietokman@gmail.com"

#property indicator_chart_window
extern int       timeFrame = 0;
extern color     colir = Red;
extern int       barsToProcess=1000;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   timeFrame = MathMax(timeFrame,Period());
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
   int lookForLength = StringLen("drp");
      for (int i=ObjectsTotal()-1; i>=0; i--) 
      {
         string name = ObjectName(i);  if (StringSubstr(name,0,lookForLength) == "drp") ObjectDelete(name);
      }
   return(0); 
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   int counted_bars=IndicatorCounted();
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           int limit=MathMin(MathMin(Bars-counted_bars,barsToProcess),Bars-1);
           int per=Period()*60;

   if (timeFrame!=Period()) { iCustom(NULL,timeFrame,WindowExpertName(),0,colir,barsToProcess,0,0);  return(0); }
   for(int i=limit; i>=0; i--)
   {
     int y = iBarShift(NULL,timeFrame,Time[i]);
     double x=0.0,
            h = iHigh(NULL,timeFrame,y),
            l = iLow(NULL,timeFrame,y),
            o = iOpen(NULL,timeFrame,y),
            c = iClose(NULL,timeFrame,y);
     if     (c<o)  x=(h+l+c+l)/2;
     else if(c>o)  x=(h+l+c+h)/2;
     else if(c==o) x=(h+l)/2;
     
     //
     //
     //
     //
     //
     
     if(ObjectGet(StringConcatenate("drp",Time[i]),OBJPROP_TIME1)==Time[0]) 
     {
        ObjectSet(StringConcatenate("drp",Time[i]),OBJPROP_PRICE1,x-l);
        ObjectSet(StringConcatenate("drp",Time[i]),OBJPROP_PRICE2,x-h);
        break;
     }
     int time=Time[i]+per;
         while(iBarShift(0,0,time,true)==-1 && time<Time[0]) time+=per; //  ""  
     string name=StringConcatenate("drp",Time[i]);
         ObjectCreate(name,OBJ_RECTANGLE,0,Time[i],x-l,time,x-h);
            ObjectSet(name,OBJPROP_COLOR,colir);
    }
   return(0);
  }
//+------------------------------------------------------------------+